
// global variables
var feed = {url:"https://www.mybillq.com/"}; // used to store the current location of the billQ server.
var scrollArea, scrollbar; // variables for the scrollarea and scrollbar.
var billToKill = null;	// the fade out and remove once its been paid.
var xml_request = null;	// xml http request variable
var user = {id:null, email:null, password:null, upgrade:'true', bill_date:null, bill_amount:null, user_amount:'Please', total_amount:'Login'};
var num_bills = 0;
var version = '2.0.2';	// widget version number
var stretcher;
var isOpen = false;
var amts = document.getElementById('amounts-container');

function toggle () {
	isOpen = (stretcher.isStretched()) ? true : false;
	var launch = document.getElementById('launch');
	var flip = document.getElementById('flip');
	var expand = document.getElementById('expand');
	if (!amts) amts = document.getElementById('amounts-container');
	
	if (isOpen) {
		launch.style.display = 'block';
		flip.style.display = 'block';
		expand.style.display = 'none';
		
		if (amts.style.opacity > 0)
			for (var i=0;i<11;i++)
				setTimeout('fadeAmounts(' + (10-i)/10 + ')',10*i);
		//amts.style.display = 'none';
	} else {
		launch.style.display = 'none';
		flip.style.display = 'none';
		expand.style.display = 'block';
		if (amts.style.opacity < 1)
			for (var i=0;i<11;i++)
				setTimeout('fadeAmounts(' + (i/10) + ')',10*i);
		//amts.style.display = 'block';
	}
} // toggle

function fadeAmounts(fade) {
	amts.style.opacity = fade;
} // fade

function selectTab(which) {
	var billsTab = document.getElementById('tab-bills');
	var bills = document.getElementById('bills');
	var addTab = document.getElementById('tab-add');
	var add = document.getElementById('add');
	billsTab.className = '';
	bills.style.display = 'none';
	addTab.className = '';
	add.style.display = 'none';
	
	if (which == 'bills') {
		billsTab.className = 'selected';
		bills.style.display = 'block';
		scrollArea.refresh();
	} else if (which == 'add') {
		addTab.className = 'selected';
		add.style.display = 'block';
		var name = document.getElementById('bill_name');
		var amount = document.getElementById('bill_amount');
		var date = document.getElementById('bill_due');
		if (name.value == '') name.value = 'Payee';
		if (amount.value == '') amount.value = user.bill_amount;
		if ((date.value == '') && (user.bill_date != null)) date.value = user.bill_date;
	}
} //selectTab

function fetchXML() {
	// make sure user is logged in...
	if ((user.id == undefined) && ((user.email == undefined) || (user.password == undefined) || (user.email == '') || (user.password == ''))) {
		setMessage('warning', 'To view your bills,<br/><span class="link" onclick="showPrefs(event);">please Login.</span>', 'icon-alert.gif');
	} else {
		setMessage('loading', '<img src="images/gr-spinner.gif" alt=""/> Loading your bills...');
		// they have login info supplied...
		// make an ajax call to billQ server to get their most list of bills.

		// makes sure the textfields are filled with the preference values
		document.getElementById("email").value = user.email;
		document.getElementById("password").value = user.password;
		
		// if there is already an xml http request established, kill it.
		if (xml_request != null) {
			xml_request.abort();
			xml_request = null;
		}
		// now create a new xml http request object
		xml_request = new XMLHttpRequest();
		// set all the variables and functions needed to have a successful xml http request call.
		xml_request.onload = function(e) {xmlLoaded(e, xml_request);}	// this is what to do when everything is done loading
		xml_request.open("POST", feed.url + "xml/?v=" + version,true);	// send an asyncronous post call
		xml_request.overrideMimeType("text/xml");						// make sure its in xml format
		xml_request.setRequestHeader("Cache-Control", "no-cache");		// don't cache anything
		xml_request.setRequestHeader('Content-Type','application/x-www-form-urlencoded'); // gotta send content type of an encoded form
	 	
		if (user.id) {
			xml_request.send("id=" + user.id + "&e=" + user.email);
		} else {
			xml_request.send("e=" + user.email + "&p=" + user.password);
		}
		//xml_request.send();
	}
}

function fetchAmounts() {
	// if there is already an xml http request established, kill it.
	if (xml_request != null) {
		xml_request.abort();
		xml_request = null;
	}
	// now create a new xml http request object
	xml_request = new XMLHttpRequest();
	// set all the variables and functions needed to have a successful xml http request call.
	xml_request.onload = function(e) {
		// just update the amounts
		var billQ = findChild(xml_request.responseXML, 'billq');
		if (!billQ) { // if there isn't a billq element, there was something wrong, so display the error message
			return;
		}
		xml_request = null;
		
		// Get the bills element from the billq element
		var bills = findChild(billQ, 'bills');
		if (!bills) { // if there isn't a bills elemenet, there was something wrong, so display the error message
			user.user_amount = '--';
			user.total_amount = '--';
		} else {
			user.user_amount = bills.getAttribute('user_amount');
			user.total_amount = bills.getAttribute('total_amount');
		}
		document.getElementById('user-amount').innerHTML = user.user_amount;
		document.getElementById('total-amount').innerHTML = user.total_amount;
	}	// this is what to do when everything is done loading
	xml_request.open("POST", feed.url + "xml/?v=" + version,true);	// send an asyncronous post call
	xml_request.overrideMimeType("text/xml");						// make sure its in xml format
	xml_request.setRequestHeader("Cache-Control", "no-cache");		// don't cache anything
	xml_request.setRequestHeader('Content-Type','application/x-www-form-urlencoded'); // gotta send content type of an encoded form
 	// send the users id and email or email and password.
	xml_request.send("id=" + user.id + "&e=" + user.email);
}

function setMessage(type, msg, img) {
	// hide contents and show message div
	var message = document.getElementById('message');
	message.style.display = 'block';
	
	// set message div
	var m = '';
	if (img != undefined)
		m += '<img src="images/' + img +'"/><br/>'
	m += msg;
	message.innerHTML = m;
	message.className = type;
}

function closeMessage() {
	document.getElementById('message').style.display = 'none';
}

function dontWarn() {
	if (window.widget)
		widget.setPreferenceForKey('false', makeKey("upgrade"));
	user.upgrade = 'false';
	closeMessage();
}

// function called when widget is loaded
function load() {
	stretcher = new Stretcher(document.getElementById('front'), 220, 250, toggle);

	// load settings
	if (window.widget) {
		user.id = widget.preferenceForKey(makeKey("id"));
		user.email = widget.preferenceForKey(makeKey("email"));
		user.password = widget.preferenceForKey(makeKey("password"));
		user.upgrade = widget.preferenceForKey(makeKey('upgrade'));
	} else {
		user.email = document.getElementById('email').value;
		user.password = document.getElementById('password').value;
	}
	
	// create new scroll bar and scroll area
	scrollbar = new AppleVerticalScrollbar(document.getElementById("myScrollBar"));
	scrollArea = new AppleScrollArea(document.getElementById("contents"), scrollbar);
	scrollArea.scrollsHorizontally = false;
	scrollArea.singlepressScrollPixels = 15;
	scrollArea.focus(); // for key control when first loading in Safari
	
	// when the widget is in focus, focus the scroll area. when its blurred, blur the scroll area.
	window.onfocus = function () { scrollArea.focus(); }
	window.onblur = function () { scrollArea.blur(); }

	stretcher.stretch();
	fetchXML();

} // load

// function called whenever the widget's front is shown.
function show() {} // show
function MyShowHandler() {
	fetchXML();
}

// when a widget is removed, destroy the preferences
function removed() {
	widget.setPreferenceForKey(null,makeKey("id"));
	widget.setPreferenceForKey(null,makeKey("email"));
	widget.setPreferenceForKey(null,makeKey("password"));
	widget.setPreferenceForKey(null,makeKey("upgrade"));
} // removed

// function called when the user wants to see the back of the widget
function showPrefs() {
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	if (window.widget)
		widget.prepareForTransition("ToBack");		// freezes the widget so that you can change it without the user noticing
	
	front.style.display="none";		// hide the front
	back.style.display="block";		// show the back
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);		// and flip the widget over	

	document.getElementById('fliprollie').style.display = 'none';  // clean up the front side - hide the circle behind the info button
} // showPrefs

// hidePrefs() is called by the done button on the back side of the widget.  It performs the opposite transition
// as showPrefs() does.
function hidePrefs() {
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	if (window.widget)
		widget.prepareForTransition("ToFront");		// freezes the widget and prepares it for the flip back to the front
	
	back.style.display="none";			// hide the back
	front.style.display="block";		// show the front
	
	// set the preference keys for the email and password
	if ((document.getElementById('email').value != user.email) || (document.getElementById('password').value != user.password)) {
	
		user.id = null;
		user.email = document.getElementById('email').value;
		user.password = document.getElementById('password').value;
		
		if (window.widget) {
			widget.setPreferenceForKey(user.email,makeKey("email"));
			widget.setPreferenceForKey(user.password,makeKey("password"));
		}
		
		fetchXML();
			
	}
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);		// and flip the widget back to the front
} // hidePrefs

// a function used to better handle dom climbing
function findChild (element, nodeName) {
	var child;
	for (child = element.firstChild; child != null; child = child.nextSibling) {
		if (child.nodeName == nodeName)
			return child;
	}	
	return null;
} // findChild

// function called when a users bill xml file is loaded in.
function xmlLoaded (e, request) {
	// reset the xml http request object
	xml_request = null;
	// if an xml was returned,
	
	if (request.responseXML) {
		// clear all the contents in the contents section
		var contents = document.getElementById('contents');
		while (contents.hasChildNodes()) {
			contents.removeChild(contents.firstChild);
		}
		scrollArea.refresh();
		closeMessage();
		
		// Get the top level <billq> element 
		var billQ = findChild(request.responseXML, 'billq');
		if (!billQ) { // if there isn't a billq element, there was something wrong, so display the error message
			var invalid = findChild(request.responseXML, 'invalid');
			if (invalid) {
				setMessage(invalid.getAttribute('type'), invalid.getAttribute('message'), 'icon-' + invalid.getAttribute('type') + '.gif');
			} else {
				setMessage('error', 'There was an error retrieving your bills from the server. Please try again later.', 'icon-error.gif');
				alert((new XMLSerializer()).serializeToString(request.responseXML));
			}
			return;
		}
		
		// Get the bills element from the billq element
		var bills = findChild(billQ, 'bills');
		// handle no bills by just putting in a dumby row...
		if (!bills) { // if there isn't a bills elemenet, there was something wrong, so display the error message
			//document.getElementById("ohnoes").style.display = "block";
			setMessage('error', 'Uh oh. Can\'t find bills.', 'icon-error.gif');
			return;
		}
		
		user.user_amount = bills.getAttribute('user_amount');
		user.total_amount = bills.getAttribute('total_amount');
		document.getElementById('user-amount').innerHTML = user.user_amount;
		document.getElementById('total-amount').innerHTML = user.total_amount;
		
		var u = findChild(billQ, 'user');
		if (u) {
			user.id = u.getAttribute('id');
			user.bill_amount = u.getAttribute('amount');
			user.bill_date = u.getAttribute('date');
			document.getElementById('bill_amount').value = user.bill_amount;
			document.getElementById('bill_due').value = user.bill_date;
		}
		
		// for each bill inside of bills,
		num_bills = 0;
		for ( var item = bills.firstChild; item != null; item = item.nextSibling) {
			if ( item.nodeName == 'bill' ) {
				// get the bills info so that we can create the bill for the widget
				var title = findChild(item, 'for');
				var amount = findChild(item, 'amount');
				var due_date = findChild(item, 'due_date');
				var group = findChild(item,'group');
				var groupName = (group != null) ? group.getAttribute('name') : null;
				var row = createRow(title.firstChild.data, item.getAttribute('id'), amount.firstChild.data, due_date.firstChild.data, item.getAttribute('class'), groupName);
				// add the bill to the contents section
				contents.appendChild(row);
				num_bills++;
			}
		}
		
		if (num_bills == 0) {
			// create a blank list item at the bottom to add the bottom line
			var row = document.createElement ('li');
			row.className = 'empty';
			row.innerHTML = "You have no upcoming bills.";
			contents.appendChild(row);
		} else {
			// create a blank list item at the bottom to add the bottom line
			var row = document.createElement ('li');
			row.className = 'blank';
			row.innerHTML = " ";
			contents.appendChild(row);
		}
		
		document.getElementById('num_bills').innerHTML = num_bills;

		// update the scrollbar so scrollbar matches new data
		scrollArea.refresh();
		
		// if there is a message, and the user hasn't requested not to get updates
		if ((billQ.getAttribute('type') != undefined) && (billQ.getAttribute('type') != '') && ((user.upgrade != 'false') || (billQ.getAttribute('message').indexOf('dontWarn()') < 0))) {
			setMessage(billQ.getAttribute('type'), billQ.getAttribute('message'), 'icon-' + billQ.getAttribute('type') + '.gif');
		}

	} else {
		setMessage('error', 'There was no response From the server. Please try again later.', 'icon-error.gif');
	}
} // xmlLoaded

// function that actually creates a bill row with supplied info
function createRow (title, id, amount, date, itemClass, group) {
	var row = document.createElement ('li');			// create a list item to contain the bill
	row.setAttribute('id', id);							// set the id
	row.setAttribute ('class', 'row ' + itemClass);		// set the class
	
	var title_div = document.createElement ('div');		// create a div to store the title
	// put in the title and an editable amount for this bill
	title_div.innerHTML = title + " (<span onclick=\"InlineEdit.start(this, 'amount', 6);\">" + amount + "</span>)";
	title_div.setAttribute ('class', 'title');			// set the class
	row.appendChild (title_div);						// add this div to the bill
	
	if (group != null) {								// if this bill belongs to a group
		var group_div = document.createElement('div');	// create a div to store the group
		group_div.innerText = "for " + group;			// add the text for the group name
		group_div.setAttribute('class', 'group');		// set the class
		row.appendChild(group_div);						// add the div to the bill
	}
	
	var date_div = document.createElement('div');		// create a div to store the date this bill is due
	date_div.innerHTML = "<span onclick=\"InlineEdit.start(this, 'date', 10);\">" + date + "</span>";		// add the text for the due date
	date_div.setAttribute('class', 'date');				// set the class
	row.appendChild(date_div);							// add the div to the bill
	
	var paid_div = document.createElement('div');		// create a div to store the paid text and checkbox
	paid_div.innerHTML = '<label>It\'s Paid <input type="checkbox" onclick="payBill(this);" /></label>'; // add the text and checkbox
	paid_div.setAttribute('class', 'paid');				// set the class
	row.appendChild(paid_div);							// add the div to the bill
	
	return row;											// return the newly created bill
} // createRow

function addBill() {
	var bill_name = document.getElementById('bill_name').value;
	var bill_amount = document.getElementById('bill_amount').value;
	var bill_due = document.getElementById('bill_due').value;
		
	if (xml_request != null) {
		xml_request.abort();
		xml_request = null;
	}
	
	// now make a new xml http request object
	xml_request = new XMLHttpRequest();
	
	// set all the variables and functions needed for a successful ajax call
	xml_request.onload = function() { 									// function to handle the successful adding of a bill
		if(xml_request.responseText=='true'){							// if bill was successfully added,
			document.getElementById('bill_name').value = '';
			document.getElementById('bill_amount').value = '';
			document.getElementById('bill_due').value = '';
			setMessage('success', 'Your bill was successfully added.<br/><span class="link" onclick="selectTab(\'bills\'); closeMessage(); fetchXML();">Click to continue</span>', 'icon-success.gif');
		} else {														// if the bill wasn't successfully added, give an error.
			setMessage('error', xml_request.responseText, 'icon-error.gif');
		}
	}
	xml_request.open("POST", feed.url + "widget/add/", true);					
	xml_request.setRequestHeader("Cache-Control", "no-cache");
	xml_request.setRequestHeader('Content-Type','application/x-www-form-urlencoded');
	xml_request.send("id=" + user.id + "&name=" + bill_name + "&amount=" + bill_amount + "&date=" + bill_due);

} // add

// when a checkbox is clicked, this function sets the bill paid on the server
// it then fades the bill out and destroys it.
function payBill(checkbox) {
	// get the supplied checkbox's bill container
	var bill = checkbox.parentNode.parentNode.parentNode;
	// get the id of that bill
	var bill_id = bill.getAttribute('id');

	// if a previous ajax call has been made, kill it.
	if (xml_request != null) {
		xml_request.abort();
		xml_request = null;
	}
	// now make a new xml http request object
	xml_request = new XMLHttpRequest();
	
	// set all the variables and functions needed for a successful ajax call
	xml_request.onload = function() { 										// function to handle the successful paying of the bill
		if(xml_request.responseText=='true'){								// if bill was successfully paid,
			billToKill = bill;												// set global variable to this bill
			for (var i=0;i<11;i++) {										// loop through 10 times
				setTimeout('setOpacity('+(10-i)+')',100*i);					// call setOpacity function to fade the bill out
			}
			num_bills--;
			document.getElementById('num_bills').innerHTML = num_bills;
			fetchAmounts();
		} else {															// if the bill wasn't successfully paid, give an error.
			bill.childNodes[bill.childNodes.length-1].innerHTML = '<span class="paid_error">Error</span>';
			setMessage('error', xml_request.responseText);
		}
	}
	xml_request.open("POST", feed.url + "bills/pay/?ajax", true);			// make an asynchronous post call to pay this bill
	xml_request.setRequestHeader("Cache-Control", "no-cache");				// dont cache anything
	xml_request.setRequestHeader('Content-Type','application/x-www-form-urlencoded');
	xml_request.send("id=" + bill_id);
} // pay
// used to fade out a bill and then remove it.
function setOpacity(value) {
	// if value isn't 0 yet, then fade the bill a little more
	if (value > 0) {
		billToKill.style.opacity = value/10;
	} else {	// otherwise, just destroy the bill and remove it completely.
		billToKill.parentNode.removeChild(billToKill);
	}
} // setOpacity

// once everything is loaded, if this is a widget, set functions to handle widget behavior
if (window.widget) {
	widget.onshow = MyShowHandler
	widget.onremove = removed;
}
